import datetime

from dajax.core import Dajax
from dajaxice.core import dajaxice_functions

from django.db.models import Q
from jumbo.shortcuts import render_to_string

from organization.models import Organization
from ticket.models import TicketProject

def ajax_on_select_organization(request, org_id, project_id=None, set_default=False):
    dajax = Dajax()
    if not org_id:
        return dajax.json()
    o = Organization.objects.get(id=org_id)

   # PROJECT
    projects = o.projects.filter(
        (Q(date_end__gte=datetime.date.today())|Q(date_end__isnull=True)),
        date_start__lte=datetime.date.today()
    )
    # se  e' un ticket vecchio devo poter visualizzare il vecchio progetto
    if project_id:
        projects = projects.filter(Q(status=1)|Q(id=project_id))
    else:
        projects = projects.filter(status=1)
    org_ticket_project = [ p.id for p in projects.all() ]
    project_user = TicketProject.objects.filter(id__in=org_ticket_project)
    option = "<option value=''></option>"
    for i, project in enumerate(project_user):
        selected = ""
        if project_id:
            if project.id == int(project_id):
                selected = " selected"
        option += "<option value='%s'%s>%s</option>" % (project.id, selected, str(project))
    dajax.assign('#id_project', 'innerHTML', option)
    return dajax.json()
dajaxice_functions.register(ajax_on_select_organization)

def ajax_on_select_project(request, project_id):
    dajax = Dajax()
    if not project_id:
        ## ho selezionato il camo vuoto
        option = ""
        dajax.assign('#id_assigned_by', 'innerHTML', option)
        dajax.assign('#id_assigned_to', 'innerHTML', option)
        return dajax.json()
    ticket_project = TicketProject.objects.get(pk=project_id)

    # ASSIGNED BY
    assigned_bys = ticket_project.managers.filter(user__is_active=True).order_by('user__last_name')
    assigned_tos = ticket_project.staff.filter(user__is_active=True).order_by('user__last_name')
    option = "<option value=''></option>"
    for i, assigned_by in enumerate(assigned_bys):
        selected = ""
#        if assigned_by.id:
#            if assigned_by.id == int(assigned_by_id):
#                selected = " selected"
        option += "<option value='%s'%s>%s</option>" % (assigned_by.id, selected, str(assigned_by))
    dajax.assign('#id_assigned_by', 'innerHTML', option)

    # ASSIGNED TO
    option_to = ""
    assigned_tos = ticket_project.staff.filter(user__is_active=True).order_by('user__last_name')
    for i, assigned_to in enumerate(assigned_tos):
        #option_from += "<option value='%s'>%s</option>" % (assigned_to.id, str(assigned_to))
        option_to += "<option value='%s'>%s</option>" % (assigned_to.id, str(assigned_to))
    dajax.assign('#id_assigned_to', 'innerHTML', option_to)
    return dajax.json()
dajaxice_functions.register(ajax_on_select_project)

def ajax_on_delete_organization(request):
    dajax = Dajax()
    option = ""
    dajax.assign('#id_project', 'innerHTML', option)
    dajax.assign('#id_assigned_by', 'innerHTML', option)
    dajax.assign('#id_assigned_to', 'innerHTML', option)
    return dajax.json()
dajaxice_functions.register(ajax_on_delete_organization)
