var NUM_PER_PAGE = 30;
var grid_assistancerow;
var URL = '/ticket/ajax/ticketassistance/list/';

Ext.onReady(function(){
    Ext.QuickTips.init();

    function renderIcon(value, p, record){
        if (value == 0) {
            return String.format("<img src='/media/img/admin/icon-no.gif' title=\"False\" />");
            }
        else {
            return String.format("<img src='/media/img/admin/icon-yes.gif' title=\"True\" />");
        }
    }

    function renderEdit(value, p, record){
        return String.format("<a href='/ticket/ticketassistance/" + record.id + "/' onclick=\"jshowAddAnotherPopup(this, 'Modifica Assistenza', 650, 800, 100, 200);return false;\"><img src='/static/jumbo/img/edit.gif' title=\"Modifica Assistenza Ticket\" /></a>");
    }

    function renderDelete(value, p, record){
        return String.format("<a href='#' onclick='confirmDelete("+record.id+")'><img src='/static/jumbo/img/del.png' title=\"Elimina Assistenza\" /></a>");
    }

    var myProxy = new Ext.data.HttpProxy({
        url: URL,
        method: 'GET'
    });

    var myReader = new Ext.data.JsonReader({
        root: 'data',
        totalProperty: 'total',
        id: 'id',
        fields: [
            {name: 'id'},
            {name: 'status'},
            {name: 'worker'},
            {name: 'date_begin'},
            {name: 'date_end'},
            {name: 'work_duration'},
            {name: 'extra_duration'},
            {name: 'travel_duration'},
            {name: 'real_duration'},
            {name: 'calculated_duration'},
            {name: 'kilometers'},
            {name: 'overnight_stay'},
            {name: 'carrying'},
            {name: 'pay_exit'},
            {name: 'edit'},
            {name: 'delete'}
        ]
    });

    var cm = new Ext.grid.ColumnModel([
        {header: "Status", width: 7, dataIndex: "status"},
        {header: "Worker", width: 10, dataIndex: "worker"},
        {header: "Date Begin", width: 15, dataIndex: "date_begin"},
        {header: "Date End", width: 15, dataIndex: "date_end"},
        {header: "Work Duration", width: 10, align: "right", dataIndex: "work_duration"},
        {header: "Travel Duration", width: 10, align: "right", dataIndex: "extra_duration"},
        {header: "Real Duration", width: 15, align: "right", dataIndex: "real_duration"},
        {header: "Calculated Duration", width: 10, align: "right", dataIndex: "calculated_duration"},
        {header: "Km", width: 5, align: "right", dataIndex: "kilometers"},
        {header: "Over Night", width: 5, align: "center", renderer: renderIcon, dataIndex: "overnight_stay"},
        {header: "Carrying", width: 10, dataIndex: "carrying"},
        {header: "Pay Exit", width: 5, align: "center", renderer: renderIcon, dataIndex: "pay_exit"},
        {header: "E", width: 5, align: "center", renderer: renderEdit, dataIndex: "edit"},
        {header: "D", width: 5, align: "center", renderer: renderDelete, dataIndex: "delete"}
    ]);
    cm.defaultSortable = true;

    ds = new Ext.data.Store({
        proxy: myProxy,
        reader: myReader,
        remoteSort: true
    });
    ds.setDefaultSort('worker', 'ASC');

    bbar = new Ext.PagingToolbar({
        pageSize: NUM_PER_PAGE,
        store: ds,
        displayInfo: true,
        displayMsg: 'Visualizzo assistenza {0} - {1} di {2}',
        emptyMsg: "Nessuna assistenza da visualizzare"
    });

    grid_assistancerow = new Ext.grid.GridPanel({
        el:'grid_assistancerow',
        title:'Lista Righe Assistenze',
        width:'99%',
        loadMask: true,
        viewConfig: {forceFit: true},
        autoHeight: true,
        enableColumnHide: false,
        store: ds,
        cm: cm,
        bbar: bbar
    });
    grid_assistancerow.render();

    grid_assistancerow.getStore().baseParams = {'ticket':id_ticket};
    // trigger the data store load
    ds.load({params:{start:0, limit:NUM_PER_PAGE}});
});

function confirmDelete(id_ticket_assistance) {
    ext_confirm = new ExtConfirm({
                        'url': '/ticket/ticketassistance/del/' + id_ticket_assistance,
                        'msgConfirm': "Sei sicuro di voler eliminare definitavamente l'assistenza?",
                        'progressText': "Cancellazione dell'assistenza in corso. Attendere..",
                        'success_msg' : "L'assistenza e' stato cancellato correttamente.",
                        'post_confirm' : reload_grid
                 });
    ext_confirm.show();
}

function reload_grid() {
    grid_assistancerow.getStore().reload();
    opener.reload_grid();
}

function close_and_reload_grid(win) {
    win.close();
    grid_assistancerow.getStore().reload();
}
